/*!
  \file stdincl.h
  \brief This file includes default headers that nearly every Class needs.
  
  no Class is defined here, but many headers to classes, and more general Headers like the openGL-header.
*/

#ifndef _STDINCL_H
#define _STDINCL_H

typedef unsigned char byte;

#include "confincl.h"

#ifdef __WIN32__
#include <windows.h>
#endif

#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include "glincl.h"

#include "error.h"
#include "debug.h"

#include "compiler.h"
#include "xmlparser/tinyxml.h"
#include "factory.h"

#define CREATE_FACTORY(x) \
		class x ## Factory : public Factory { \
		 public:	\
		  x ## Factory (){setNext( NULL); setClassname( #x ); initialize();} \
		  ~x ## Factory () {}; \
		 private: \
			BaseObject* fabricate( TiXmlElement* root) \
			{ \
				if(!strcmp(root->Value(), getClassname())) return new  x ( root); \
				else if( getNext() != NULL) return getNext()->fabricate( root); \
				else return NULL; \
			} \
		}; \
		x ## Factory global_ ## x ## Factory;
		
#endif /* _STDINCL_H */
